## opensnitch 1.6.9

=== Makefile ===
all: protocol opensnitch_daemon gui

install:
	@cd daemon && make install	
	@cd ui && make install

protocol:
	@cd proto && make

opensnitch_daemon:
	@cd daemon && make

gui:
	@cd ui && make

clean:
	@cd daemon && make clean
	@cd proto && make clean
	@cd ui && make clean

run:
	cd ui && pip3 install --upgrade . && cd ..
	opensnitch-ui --socket unix:///tmp/osui.sock &
	./daemon/opensnitchd -rules-path /etc/opensnitchd/rules -ui-socket unix:///tmp/osui.sock -cpu-profile cpu.profile -mem-profile mem.profile

test: 
	clear 
	make clean
	clear
	mkdir -p rules
	make 
	clear
	make run

adblocker:
	clear 
	make clean
	clear
	make 
	clear
	python make_ads_rules.py
	clear
	cd ui && pip3 install --upgrade . && cd ..
	opensnitch-ui --socket unix:///tmp/osui.sock &
	./daemon/opensnitchd -rules-path /etc/opensnitchd/rules -ui-socket unix:///tmp/osui.sock

=== daemon/Makefile ===
#SRC contains all *.go *.c *.h files in daemon/ and its subfolders 
SRC := $(shell find . -type f -name '*.go' -o -name '*.h' -o -name '*.c')
PREFIX?=/usr/local

all: opensnitchd

install:
	@mkdir -p $(DESTDIR)/etc/opensnitchd/rules
	@install -Dm755 opensnitchd \
		-t $(DESTDIR)$(PREFIX)/bin/
	@install -Dm644 opensnitchd.service \
		-t $(DESTDIR)/etc/systemd/system/
	@install -Dm644 default-config.json \
		-t $(DESTDIR)/etc/opensnitchd/
	@install -Dm644 system-fw.json \
		-t $(DESTDIR)/etc/opensnitchd/
	@systemctl daemon-reload

opensnitchd: $(SRC)
	@go get
	@go build -o opensnitchd . 

clean:
	@rm -rf opensnitchd

=== ebpf_prog/Makefile ===
# OpenSnitch - 2023
#
# On Debian based distros we need the following 2 directories.
# Otherwise, just use the kernel headers from the kernel sources.
#
KERNEL_DIR ?= /lib/modules/$(shell uname -r)/source
KERNEL_HEADERS ?= /usr/src/linux-headers-$(shell uname -r)/
CLANG ?= clang
LLC ?= llc
LLVM_STRIP ?= llvm-strip -g
ARCH ?= $(shell uname -m)

# as in /usr/src/linux-headers-*/arch/
# TODO: extract correctly the archs, and add more if needed.
ifeq ($(ARCH),x86_64)
	ARCH := x86
else ifeq ($(ARCH),i686)
	ARCH := x86
else ifeq ($(ARCH),armv7l)
	ARCH := arm
else ifeq ($(ARCH),aarch64)
	ARCH := arm64
endif

ifeq ($(ARCH),arm)
	# on previous archs, it fails with "SMP not supported on pre-ARMv6"
	EXTRA_FLAGS = "-D__LINUX_ARM_ARCH__=7"
endif

BIN := opensnitch.o opensnitch-procs.o opensnitch-dns.o
CLANG_FLAGS = -I. \
	-I$(KERNEL_HEADERS)/arch/$(ARCH)/include/generated/ \
	-I$(KERNEL_HEADERS)/include \
	-include $(KERNEL_DIR)/include/linux/kconfig.h \
	-I$(KERNEL_DIR)/include \
	-I$(KERNEL_DIR)/include/uapi \
	-I$(KERNEL_DIR)/include/generated/uapi \
	-I$(KERNEL_DIR)/arch/$(ARCH)/include \
	-I$(KERNEL_DIR)/arch/$(ARCH)/include/generated \
	-I$(KERNEL_DIR)/arch/$(ARCH)/include/uapi \
	-I$(KERNEL_DIR)/arch/$(ARCH)/include/generated/uapi \
	-I$(KERNEL_DIR)/tools/testing/selftests/bpf/ \
	-D__KERNEL__ -D__BPF_TRACING__ -Wno-unused-value -Wno-pointer-sign \
	-D__TARGET_ARCH_$(ARCH) -Wno-compare-distinct-pointer-types \
	$(EXTRA_FLAGS) \
	-Wno-gnu-variable-sized-type-not-at-end \
	-Wno-address-of-packed-member -Wno-tautological-compare \
	-Wno-unknown-warning-option  \
	-g -O2 -emit-llvm

all: $(BIN)

%.o: %.c
	$(CLANG) $(CLANG_FLAGS) -c $< -o $@.partial
	$(LLC) -march=bpf -mcpu=generic -filetype=obj -o $@ $@.partial
	rm -f $@.partial

clean:
	rm -f *.o *.partial

=== proto/Makefile ===
all: ../daemon/ui/protocol/ui.pb.go ../ui/opensnitch/ui_pb2.py

../daemon/ui/protocol/ui.pb.go: ui.proto
	protoc -I. ui.proto --go_out=../daemon/ui/protocol/ --go-grpc_out=../daemon/ui/protocol/ --go_opt=paths=source_relative --go-grpc_opt=paths=source_relative

../ui/opensnitch/ui_pb2.py: ui.proto
	python3 -m grpc_tools.protoc -I. --python_out=../ui/opensnitch/ --grpc_python_out=../ui/opensnitch/ ui.proto

clean:
	@rm -rf ../daemon/ui/protocol/ui.pb.go
	@rm -rf ../daemon/ui/protocol/ui_grpc.pb.go
	@rm -rf ../ui/opensnitch/ui_pb2.py
	@rm -rf ../ui/opensnitch/ui_pb2_grpc.py

=== ui/Makefile ===
all: opensnitch/resources_rc.py

install:
	@pip3 install --upgrade .

opensnitch/resources_rc.py: translations deps
	@pyrcc5 -o opensnitch/resources_rc.py opensnitch/res/resources.qrc
	@find opensnitch/proto/ -name 'ui_pb2_grpc.py' -exec sed -i 's/^import ui_pb2/from . import ui_pb2/' {} \;

translations:
	@cd i18n ; make
	
deps:
	@pip3 install -r requirements.txt

clean:
	@rm -rf *.pyc
	@rm -rf opensnitch/resources_rc.py
	@find i18n/ -name '*.qm' -delete

=== ui/requirements.txt ===
grpcio-tools>=1.10.1
pyinotify==0.9.6
unicode_slugify==0.1.5
pyqt5>=5.6
protobuf

=== debian/changelog ===
opensnitch (1.6.9-3ubuntu1) questing; urgency=medium

  * Merge with Debian unstable (LP: #2116578). Remaining changes:
    - Fix FTBFS due to kernel headers (LP: 2112262)
      + 2050-fix-kernel-headers-folder.patch
      + 2051-add-ebpf-rule-mapping-for-riscv.patch

 -- Massimiliano Pellizzer <massimiliano.pellizzer@canonical.com>  Fri, 04 Jul 2025 16:29:17 +0000

opensnitch (1.6.9-3) unstable; urgency=medium

  * Added python3-packaging as runtime dependency for
    python3-opensnitch-ui, seem to need it.
  * Corrected name of README.sources and updated to reflect new
    reality.

 -- Petter Reinholdtsen <pere@debian.org>  Tue, 24 Jun 2025 07:47:33 +0200

opensnitch (1.6.9-2ubuntu1) questing; urgency=medium

  * Fix FTBFS due to kernel headers (LP: #2112262)
    - 2050-fix-kernel-headers-folder.patch
    - 2051-add-ebpf-rule-mapping-for-riscv.patch

 -- Massimiliano Pellizzer <massimiliano.pellizzer@canonical.com>  Sat, 31 May 2025 09:10:56 +0200

opensnitch (1.6.9-2) unstable; urgency=medium

  * Team upload.

  * Told lintian to accept EBPF objects in package.

 -- Petter Reinholdtsen <pere@debian.org>  Sat, 03 May 2025 05:50:32 +0200

opensnitch (1.6.9-1) experimental; urgency=medium

  * Team upload.

  * New upstream release 1.6.9.
  * Removed upstreamed patches:
    - 0000-ui-finally-service.patch
    - 0020-unknown-rules-operator-crash.patch
    - 0030-daemon-visible-version.patch
    - 0040-delete-all-generated-protobuffers-with-make-clean.patch
    - 0050-allow-to-configure-GC-percentage.patch
    - 0060-make-connections-flushing-configurable.patch

 -- Petter Reinholdtsen <pere@debian.org>  Tue, 29 Apr 2025 07:35:00 +0200

opensnitch (1.6.8-11) unstable; urgency=medium

  * Team upload.

  * Corrected typo in patch metadata.

 -- Petter Reinholdtsen <pere@debian.org>  Tue, 29 Apr 2025 07:20:39 +0200

opensnitch (1.6.8-10) experimental; urgency=medium

  * Team upload.

  * Added 1050-ebpf-s390x.patch to fix ebpf build problem on s390x.
  * Renamed to 0030-daemon-visible-version.patch as this patch
    is from upstream now.
  * Removed already dropped 0010-experimental-1.5.9.1.patch.
  * Added three patches from the upstream 1.6.0 branch.
  * Changed opensnitch package behaviour to not reset TCP connections on
    reload (Closes: #1103496).

 -- Petter Reinholdtsen <pere@debian.org>  Sat, 26 Apr 2025 07:45:17 +0200

opensnitch (1.6.8-9) experimental; urgency=medium

  * Team upoad.

  * Added 2000-apt-not-pip.patch to recommend apt over pip.
  * Passed patches upstream and introduced patch naming scheme.
  * Added 1030-systemd-service-earlier.patch to start service earlier
    and protect it from kernel OOM killer.
  * Added 1040-daemon-visible-version.patch to correct visible daemon
    version.
  * Added 0020-unknown-rules-operator-crash.patch from upstream.
  * Added needrestart conf to avoid opensnitch restarts.
  * Added debian branch name to d/gbp.conf.

 -- Petter Reinholdtsen <pere@debian.org>  Thu, 24 Apr 2025 06:50:04 +0200

opensnitch (1.6.8-8) unstable; urgency=medium

  * Team upload.

  * Made test-fw-rules.sh autopkgtest check more robust
    and updated it to only look for nftables.

 -- Petter Reinholdtsen <pere@debian.org>  Fri, 18 Apr 2025 19:46:18 +0200

opensnitch (1.6.8-7) unstable; urgency=medium

  * Team upload.

  * Upload to unstable.

 -- Petter Reinholdtsen <pere@debian.org>  Fri, 18 Apr 2025 01:32:00 +0200

opensnitch (1.6.8-6) experimental; urgency=medium

  * Team upload.

  * Replaced uploaders, out with no longer active Gustavo Iñiguez Goya
    and in with Charles Allhands and myself.
  * Thank you, Gustavo, for the great initial work with this package.

 -- Petter Reinholdtsen <pere@debian.org>  Fri, 18 Apr 2025 00:38:08 +0200

opensnitch (1.6.8-5) experimental; urgency=medium

  * Team upload.

  * Revert arch specific build dependency on golang-github-iovisor-gobpf-dev.
  * Added 1010-ui-finally-service.patch to avoid python error on GUI exit.
  * New upstream version available (Closes: #1051317).
  * Uses corrected python regexes (Closes: #1085754).

 -- Petter Reinholdtsen <pere@debian.org>  Thu, 17 Apr 2025 16:34:43 +0200

opensnitch (1.6.8-4) experimental; urgency=medium

  * Team upload.

  * Corrected linux header package name for armhf.
  * Limit EBPF support to architectures provided by bpfcc.
  * Adjusted opensnitch to only recommend opensnitch-ebpf-modules on archs
    where it exist.
  * Dropped incorrect runtime dependency on python3-setuptools
    (Closes: #1095252).
  * Dropped obsolete runtime dependency on python3-six (Closes: #1067722).

 -- Petter Reinholdtsen <pere@debian.org>  Thu, 17 Apr 2025 14:45:27 +0200

opensnitch (1.6.8-3) experimental; urgency=medium

  * Team upload.

  * Switched to using kernel headers from debs, as local header copy
    only worked on amd64.

 -- Petter Reinholdtsen <pere@debian.org>  Thu, 17 Apr 2025 12:54:58 +0200

opensnitch (1.6.8-2) experimental; urgency=medium

  * Team upload.

  * Added missing golang-github-varlink-go-dev build dependency.

 -- Petter Reinholdtsen <pere@debian.org>  Thu, 17 Apr 2025 10:55:29 +0200

opensnitch (1.6.8-1) experimental; urgency=medium

  * Team upload.

  * New upstream release.
  * Updated Standards-Version from 4.6.2 to 4.7.2.
  * List protoc-gen-go-1-3 as build depend alternative to protoc-gen-go-1-5
    for easier backporting.

 -- Petter Reinholdtsen <pere@debian.org>  Thu, 17 Apr 2025 09:08:49 +0200

opensnitch (1.5.9-4) experimental; urgency=medium

  * Team upload.

  * Added leftover build dependency protoc-gen-go-1-5.

 -- Petter Reinholdtsen <pere@debian.org>  Tue, 15 Apr 2025 06:18:52 +0200

opensnitch (1.5.9-3) experimental; urgency=medium

  * Team upload.

  [ Gustavo Iñiguez Goya ]
  * New upstream release.
  * d/control: removed kernel headers dependency.

  [ Petter Reinholdtsen ]
  * Moved untagged upstream snapshot into 0010-experimental-1.5.9.1.patch.
  * Adjusted build dependencies to work with current unstable.


=== debian/control ===
Source: opensnitch
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders:
 Charles Allhands <cra@resistentialist.com>,
 Petter Reinholdtsen <pere@debian.org>
Section: devel
Priority: optional
Build-Depends:
 debhelper-compat (= 11),
 dh-golang,
 dh-python,
 golang-any,
 golang-github-fsnotify-fsnotify-dev,
 golang-github-google-gopacket-dev,
 golang-github-google-nftables-dev,
 golang-github-iovisor-gobpf-dev,
 golang-github-varlink-go-dev,
 golang-github-vishvananda-netlink-dev,
 golang-golang-x-net-dev,
 golang-google-grpc-dev,
 golang-github-gogo-protobuf-dev | golang-goprotobuf-dev,
 libmnl-dev,
 libnetfilter-queue-dev,
 linux-headers-amd64 [amd64] | linux-headers-arm64 [arm64] | linux-headers-armmp [armhf] | linux-headers-loong64 [loong64] | linux-headers-riscv64 [riscv64] | linux-headers-s390x [s390x] | linux-headers-generic,
 pkgconf,
 protoc-gen-go-1-5 | protoc-gen-go-1-3,
 protoc-gen-go-grpc,
 pyqt5-dev-tools,
 qttools5-dev-tools,
 python3-all,
 python3-grpc-tools,
 python3-setuptools,
 clang,
 llvm
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/go-team/packages/opensnitch
Vcs-Git: https://salsa.debian.org/go-team/packages/opensnitch.git
Homepage: https://github.com/evilsocket/opensnitch
Rules-Requires-Root: no
XS-Go-Import-Path: github.com/evilsocket/opensnitch

Package: opensnitch
Section: net
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends: python3-opensnitch-ui,
 opensnitch-ebpf-modules [amd64 arm64 riscv64 s390x loong64 ppc64]
Built-Using: ${misc:Built-Using}
Description: GNU/Linux interactive application firewall
 Whenever a program makes a connection, it'll prompt the user to allow or deny
 it.
 .
 The user can decide if block the outgoing connection based on properties of
 the connection: by port, by uid, by dst ip, by program or a combination
 of them.
 .
 These rules can last forever, until the app restart or just one time.
 .
 The GUI allows the user to view live outgoing connections, as well as search
 by process, user, host or port.
 .
 OpenSnitch can also work as a system-wide domains blocker, by using lists
 of domains, list of IPs or list of regular expressions.


Package: python3-opensnitch-ui
Architecture: all
Section: net
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libqt5sql5-sqlite,
 python3-grpcio,
 python3-notify2,
 python3-packaging,
 python3-pyinotify,
 python3-pyqt5,
 python3-pyqt5.qtsql,
 python3-slugify,
 python3:any,
 xdg-user-dirs,
 gtk-update-icon-cache
Recommends:
 python3-pyasn
Suggests: opensnitch
Description: GNU/Linux interactive application firewall GUI
 opensnitch-ui is a GUI for opensnitch written in Python.
 It allows the user to view live outgoing connections, as well as search
 for details of the intercepted connections.
 .
 The user can decide if block outgoing connections based on properties of
 the connection: by port, by uid, by dst ip, by program or a combination
 of them.
 .
 These rules can last forever, until restart the daemon or just one time.
 .
 OpenSnitch can also work as a system-wide domains blocker, by using lists
 of domains, list of IPs or list of regular expressions.


Package: opensnitch-ebpf-modules
Architecture: amd64 arm64 riscv64 s390x loong64 ppc64
Section: net
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests: opensnitch
Description: GNU/Linux interactive application firewall eBPF modules
 opensnitch-ebpf-modules provides the eBPF modules.
 It provides the functionality to intercept connections at kernel level,
 offering better performance and reliability.

=== debian/rules ===
#!/usr/bin/make -f
export DH_VERBOSE = 1
export DESTDIR := $(shell pwd)/debian/opensnitch
export UIDESTDIR := $(shell pwd)/debian/python3-opensnitch-ui
export EBPFDESTDIR := $(shell pwd)/debian/opensnitch-ebpf-modules

ifeq ($(DEB_BUILD_ARCH),amd64)
  WITH_EBPF := true
else ifeq ($(DEB_BUILD_ARCH),arm64)
  WITH_EBPF := true
else ifeq ($(DEB_BUILD_ARCH),riscv64)
  WITH_EBPF := true
else ifeq ($(DEB_BUILD_ARCH),s390x)
  WITH_EBPF := true
else ifeq ($(DEB_BUILD_ARCH),loong64)
  WITH_EBPF := true
else ifeq ($(DEB_BUILD_ARCH),ppc64)
  WITH_EBPF := true
else
  WITH_EBPF := false
endif

override_dh_installsystemd:
	dh_installsystemd --restart-after-upgrade

override_dh_auto_build:
	$(MAKE) protocol
# Workaround for Go build problem when building in _build
	mkdir -p _build/src/github.com/evilsocket/opensnitch/daemon/ui/protocol/
	cp daemon/ui/protocol/* _build/src/github.com/evilsocket/opensnitch/daemon/ui/protocol/
	dh_auto_build
	cd ui && python3 setup.py build --force
	if $(WITH_EBPF) ; then make -C ebpf_prog; fi

override_dh_auto_install:
# daemon
	mkdir -p $(DESTDIR)/usr/bin
	cp _build/bin/daemon $(DESTDIR)/usr/bin/opensnitchd
# GUI
	make -C ui/i18n
	cp -r ui/i18n/locales/ ui/opensnitch/i18n/
	pyrcc5 -o ui/opensnitch/resources_rc.py ui/opensnitch/res/resources.qrc
	sed -i 's/^import ui_pb2/from . import ui_pb2/' ui/opensnitch/ui_pb2*
	cd ui && python3 setup.py install --force --root=$(UIDESTDIR) --no-compile -O0 --install-layout=deb

# ebpf modules
	if $(WITH_EBPF); then \
	  mkdir -p $(EBPFDESTDIR)/usr/lib/opensnitchd/ebpf ; \
	  make -C ebpf_prog && cp ebpf_prog/opensnitch*o $(EBPFDESTDIR)/usr/lib/opensnitchd/ebpf/ ; \
	fi

# daemon
	dh_auto_install

%:
	dh $@ --builddirectory=_build --buildsystem=golang --with=golang,python3

override_dh_auto_clean:
	dh_auto_clean
	$(MAKE) clean
	$(RM) daemon/ui/protocol/ui_grpc.pb.go
	$(RM) ui/opensnitch/resources_rc.py
	$(RM) -r ui/opensnitch/i18n/
	$(RM) ui/i18n/locales/*/*.qm
	cd ui && python3 setup.py clean -a
	$(RM) -r ui/opensnitch_ui.egg-info/
	find ui -name \*.pyc -exec rm {} \;
	$(MAKE) -C ebpf_prog/ clean
